#!/bin/bash
### Copyright 1999-2025. WebPros International GmbH. All rights reserved.
#
#
# Plesk script
#
#default values
### Copyright 1999-2025. WebPros International GmbH. All rights reserved.
set_apache_params()
{
apache_user="www-data"
apache_UID=80
apache_group="www-data"
apache_GID=80
apache_pid_file="$APACHE_ROOT/logs/httpd.pid"
apache_lock_file="$APACHE_ROOT/logs/httpd.lock"
product_lock_file="$HTTPD_CONF_D/cnf.lock"
apache_service_name="apache2"
apache_modules_d="/usr/lib/apache2/modules"
apache_service="$apache_service_name"
apache_httpd_conf="$HTTPD_CONF_D/apache2.conf"
apache_httpd_include="$HTTPD_INCLUDE_D/zz010_psa_httpd.conf"
APACHE_ROOT="/usr"
min_suexec_UID=10000
max_suexec_UID=16000
min_suexec_GID=$min_suexec_UID
max_suexec_GID=$max_suexec_UID
suexec_storage=/usr/lib/plesk-9.0/suexec
suexec=/usr/lib/apache2/suexec
suexec_dir="`dirname "$suexec"`"
suexec_file="`basename "$suexec"`"
rpm_httpd_bin=/usr/sbin/httpd
}
### Copyright 1999-2025. WebPros International GmbH. All rights reserved.
# mode: shell-script
# vim: ft=sh
module_exists()
{
local dir
[ -n "$1" ] || return 1
test -e "${HTTPD_CONF_D}/mods-available/$1.load" && return
if [ -n "${additional_apache_modules_d}" ]; then
for dir in $additional_apache_modules_d; do
if [ -f "${dir}/mod_$1.so" ] ; then return ; fi
if [ -n "$2" -a -f "${dir}/$2" ] ; then return ; fi
done
fi
return 1
}
# Run before it
# read_conf
# # set_common_params
# set_apache_params
add_apache_module()
{
local module_name="$1"
local module_soname="$2" # optional
local config="$3" # optional
if ! module_exists $module_name "$module_soname"; then
p_echo "Load file ${HTTPD_CONF_D}/mods-available/$module_name.load for a2enmod not found"
return 1
fi
if [ -x /usr/sbin/a2enmod ]; then
/usr/sbin/a2enmod $module_name >> $product_log
else
warn "a2enmod utilily not found! Module $module_name was NOT enabled."
fi
}
# Run before it
# read_conf
# # set_common_params
# set_apache_params
remove_apache_module()
{
local module_name="$1"
local module_soname="$2" # optional
local config="$3" # optional
if [ -x /usr/sbin/a2dismod ]; then
/usr/sbin/a2dismod -f $module_name
else
warn "a2dismod utilily not found! Module $module_name was NOT disabled."
fi
}
is_function()
{
local type_output=$(type -t "$1")
test "X${type_output}" = "Xfunction"
}
# echo message to product log, also to console in debug mode
p_echo()
{
if [ -n "$product_log" ] ; then
echo "$@" >> "$product_log" 2>&1
fi
if [ -n "$PLESK_INSTALLER_DEBUG" -o -n "$PLESK_INSTALLER_VERBOSE" -o -z "$product_log" ] ; then
echo "$@" >&2
fi
}
# same as p_echo, but without new line
pnnl_echo()
{
p_echo -n "$@"
}
int_err()
{
report_problem "internal" "Internal error: $@"
exit 1
}
p_see_product_log()
{
log_is_in_dev "${product_log}" || printf " (see log file: ${product_log})" >&2
}
die()
{
report_problem "fatal" "ERROR while trying to $@"
printf "Check the error reason" >&2
p_see_product_log
echo ", fix and try again" >&2
selinux_close
exit 1
}
warn()
{
local inten="$1"
if [ -n "$PLESK_INSTALLER_DEBUG" -o -n "$PLESK_INSTALLER_VERBOSE" ]; then
p_echo
p_echo "WARNING!"
pnnl_echo "Some problems are found during $inten"
p_see_product_log
p_echo
p_echo "Continue..."
p_echo
fi
report_problem "warning" "Warning: $inten"
}
echo_try()
{
msg="$*"
pnnl_echo " Trying to $msg... "
}
suc()
{
p_echo "done"
}
### Copyright 1999-2025. WebPros International GmbH. All rights reserved.
reexec_with_clean_env()
{
# Usage: call this function as 'reexec_with_clean_env "$@"' at the start of a script.
# Don't use with scripts that require sensitive environment variables.
# Don't put the call under any input/output redirection.
# Purpose: make sure the script is executed with a sane environment.
local lc="`get_default_locale`"
export LANG="$lc" LC_MESSAGES="$lc" LC_ALL="$lc"
export PATH=/sbin:/bin:/usr/sbin:/usr/bin:/usr/local/sbin:/usr/local/bin
umask 022
PLESK_SCRIPT_COMMAND_LINE="$0 $*"
[ -z "$PLESK_INSTALLER_ENV_CLEANED" ] || { unset PLESK_INSTALLER_ENV_CLEANED; return 0; }
[ -n "$BASH" ] || exec /bin/bash "$0" "$@"
# N.B.: the following code requires Bash. On Dash it would cause syntax error upon parse w/o eval.
eval '
local extra_vars=() # list of variables to preserve
for var in "${!PLESK_@}"; do # enumerate all PLESK_* variables
extra_vars+=("$var=${!var}")
done
extra_vars+=("PLESK_INSTALLER_ENV_CLEANED=1")
# Exec self with clean env except for extra_vars, shell opts, and arguments.
exec /usr/bin/env -i "${extra_vars[@]}" /bin/bash ${-:+-$-} "$0" "$@" || {
echo "Failed to reexec self ($0) with clean environment" >&2
exit 91 # Just some relatively unique error code
}
'
}
get_default_locale()
{
# Note that CentOS 7 typically doesn't have C.UTF-8
for lc in "C.UTF-8" "en_US.UTF-8" "C"; do
if [ -z "`LC_ALL=$lc locale 2>&1 >/dev/null`" ]; then
echo "$lc"
return 0
fi
done
echo "C"
}
# accumulates chown and chmod
set_ac()
{
local u_owner g_owner perms node
u_owner="$1"
g_owner="$2"
perms="$3"
node="$4"
# A very small optimization - replacing of two execs by one,
# it works only if the following conditions are observed:
# - u_owner is username (not UID);
# - g_owner is group (not GID);
# - perms is in octal mode.
# If some conditions aren't observed,
# optimization doesn't work,
# but it doesn't break function
[ "$(stat -c '%U:%G 0%a' $node)" != "$u_owner:$g_owner $perms" ] || return 0
chown $u_owner:$g_owner $node || die "chown $u_owner:$g_owner $node"
chmod $perms $node || die "chmod $perms $node"
}
detect_vz()
{
[ -z "$PLESK_VZ_RESULT" ] || return $PLESK_VZ_RESULT
PLESK_VZ_RESULT=1
PLESK_VZ=0
PLESK_VE_HW_NODE=0
PLESK_VZ_TYPE=
local issue_file="/etc/issue"
local vzcheck_file="/proc/self/status"
[ -f "$vzcheck_file" ] || return 1
local env_id=`sed -ne 's|^envID\:[[:space:]]*\([[:digit:]]\+\)$|\1|p' "$vzcheck_file"`
[ -n "$env_id" ] || return 1
if [ "$env_id" = "0" ]; then
# Either VZ/OpenVZ HW node or unjailed CloudLinux
PLESK_VE_HW_NODE=1
return 1
fi
if grep -q "CloudLinux" "$issue_file" >/dev/null 2>&1 ; then
return 1
fi
if [ -f "/proc/vz/veredir" ]; then
PLESK_VZ_TYPE="vz"
elif [ -d "/proc/vz" ]; then
PLESK_VZ_TYPE="openvz"
fi
PLESK_VZ=1
PLESK_VZ_RESULT=0
return 0
}
# detects lxc and docker containers
detect_lxc()
{
[ -z "$PLESK_LXC_RESULT" ] || return $PLESK_LXC_RESULT
PLESK_LXC_RESULT=1
PLESK_LXC=0
if { [ -f /proc/1/cgroup ] && grep -q 'docker\|lxc' /proc/1/cgroup; } || \
{ [ -f /proc/1/environ ] && cat /proc/1/environ | tr \\0 \\n | grep -q "container=lxc"; };
then
PLESK_LXC_RESULT=0
PLESK_LXC=1
fi
return "$PLESK_LXC_RESULT"
}
call_optional_function()
{
local type_output="`LC_ALL=C type \"$1\" 2>/dev/null | head -n 1`"
case "$type_output" in
*function)
"$@"
;;
*)
return 0
;;
esac
}
### Copyright 1999-2025. WebPros International GmbH. All rights reserved.
#-*- vim:syntax=sh
product_log_name_ex()
{
local aux_descr="$1"
local action="${CUSTOM_LOG_ACTION_NAME-installation}"
if [ -n "$aux_descr" ]; then
aux_descr="_${aux_descr}"
fi
if [ -n "$CUSTOM_LOG_NAME" ]; then
echo "${CUSTOM_LOG_NAME}${action:+_$action}${aux_descr}.log"
else
get_product_versions
echo "plesk_${product_this_version}${action:+_$action}${aux_descr}.log"
fi
}
product_log_name()
{
product_log_name_ex
}
product_problems_log_name()
{
product_log_name_ex "problems"
}
problems_log_tail()
{
[ -f "$product_problems_log" ] || return 0
{
tac "$product_problems_log" | awk '/^START/ { exit } { print }' | tac
} 2>/dev/null
}
product_log_tail()
{
[ -f "$product_log" ] || return 0
{
tac "$product_log" | awk '/^START/ { exit } { print }' | tac
} 2>/dev/null
}
product_and_problems_log_tail()
{
product_log_tail
[ "$product_log" = "$product_problems_log" ] || problems_log_tail
}
cleanup_problems_log()
{
[ -f "$product_problems_log" ] || return 0
touch "$product_problems_log.tmp"
chmod 0600 "$product_problems_log.tmp"
awk 'BEGIN { st = "" }
/^START/ && (st ~ /^START/) { print st; }
/^START/ { st=$0; next }
/^STOP/ && (st ~ /^START/) { st=""; next }
(st != "") { print st; st="" }
{ print }
' "$product_problems_log" > "$product_problems_log.tmp" && \
mv -f "$product_problems_log.tmp" "$product_problems_log" || \
rm -f "$product_problems_log.tmp"
if [ ! -s "$product_problems_log" ]; then
rm -f "$product_problems_log"
fi
}
mktemp_log()
{
local logname="$1"
local dir="$2"
if [ "${logname:0:1}" != "/" ]; then
logname="$dir/$logname"
fi
dir="`dirname $logname`"
if [ ! -d "$dir" ]; then
mkdir -p "$dir" || { echo "Unable to create log directory : $dir"; exit 1; }
if [ "$EUID" -eq "0" ]; then
set_ac root root 0700 "$dir"
fi
fi
if [ "${logname%XXX}" != "$logname" ]; then
mktemp "$logname"
else
echo "$logname"
fi
}
log_is_in_dev()
{
test "${1:0:5}" = "/dev/"
}
start_writing_logfile()
{
local logfile="$1"
local title="$2"
! log_is_in_dev "$logfile" || return 0
echo "START $title" >> "$logfile" || { echo "Cannot write installation log $logfile" >&2; exit 1; }
[ "$EUID" -ne "0" ] || set_ac root root 0600 "$logfile"
}
log_start()
{
true product_log_name product_problems_log_name mktemp_log
local title="$1"
local custom_log="$2"
local custom_problems_log="$3"
local product_log_dir="/var/log/plesk/install"
product_log="$product_log_dir/`product_log_name`"
product_problems_log="$product_log_dir/`product_problems_log_name`"
problems_occured=0
# init product log
[ ! -n "$custom_log" ] || product_log="$custom_log"
product_log=`mktemp_log "$product_log" "$product_log_dir"`
# init problems log
if [ -n "$custom_problems_log" ]; then
product_problems_log=`mktemp_log "$custom_problems_log" "$product_log_dir"`
elif [ -n "$custom_log" ]; then
product_problems_log="$product_log"
else
product_problems_log=`mktemp_log "$product_problems_log" "$product_log_dir"`
fi
# write starting message into logs
start_writing_logfile "$product_log" "$title"
if [ "$product_log" != "$product_problems_log" ]; then
start_writing_logfile "$product_problems_log" "$title"
fi
is_function profiler_setup && profiler_setup "$title" || :
}
log_transaction_start()
{
LOG_TRANSACTION_TITLE="$1"
LOG_TRANSACTION_SUBJECT="$2"
local log_transaction_custom_logfile="$3"
local log_transaction_custom_problems_logfile="$4"
transaction_begin autocommit
log_start "$LOG_TRANSACTION_TITLE" "$log_transaction_custom_logfile" "$log_transaction_custom_problems_logfile"
transaction_add_commit_action "log_transaction_stop"
transaction_add_rollback_action "log_transaction_stop"
}
log_transaction_stop()
{
log_stop "$LOG_TRANSACTION_TITLE" "$LOG_TRANSACTION_SUBJECT"
}
log_stop()
{
local title="$1"
local subject="$2"
if [ "$product_log" = "$product_problems_log" ] || \
log_is_in_dev "$product_problems_log"; then
[ -e "$product_log" ] && echo "STOP $title" >>"$product_log"
is_function profiler_stop && profiler_stop || :
return
fi
if [ -z "$subject" ]; then
subject="[${title}]"
fi
# check if problems are non-empty, check for problems_occured
local status
local problem_lines="`problems_log_tail | wc -l`"
if [ "$problem_lines" -eq 0 ]; then
status="completed successfully"
else
if [ $problems_occured -ne 0 ]; then
status="failed"
else
status="completed with warnings"
fi
fi
if [ -e "$product_log" ]; then
p_echo
p_echo "**** $subject $status."
p_echo
fi
if [ "$problem_lines" -ne 0 ]; then
[ ! -e "$product_log" ] || problems_log_tail >>"$product_log" 2>&1
problems_log_tail
fi
[ ! -e "$product_log" ] || echo "STOP $title" >>"$product_log"
if [ $problems_occured -ne 0 ]; then
echo "STOP $title: PROBLEMS FOUND" >>"$product_problems_log"
else
[ ! -s "$product_problems_log" ] || echo "STOP $title: OK" >>"$product_problems_log"
fi
if [ "X${PLESK_INSTALLER_KEEP_PROBLEMS_LOG}" = "X" ]; then
cleanup_problems_log
fi
is_function profiler_stop && profiler_stop || :
}
### Copyright 1999-2025. WebPros International GmbH. All rights reserved.
construct_report_template()
{
local severity="${1:-error}"
local summary="$2"
local update_ticket="`get_update_ticket`"
set_error_report_source
set_error_report_component
set_error_report_params
set_error_report_environment
true construct_report_code construct_report_debug construct_report_message
cat <<-EOL
$report_source$severity`date --iso-8601=seconds`$report_component/] ]>/g'`]]>`construct_report_message | base64`$report_params`construct_report_code | base64``construct_report_debug | base64`$report_environment$update_ticket
EOL
}
construct_report_code()
{
local call_level=${1:-5}
local func_level=$[call_level - 1]
local lineno_func=${BASH_LINENO[ $func_level ]}
local script_name=${BASH_SOURCE[ $[func_level + 1] ]}
echo "# Call of ${FUNCNAME[$func_level]}() from ${FUNCNAME[$[func_level + 1]]}() at `readlink -m $script_name`:${BASH_LINENO[$func_level]}"
head -n $[lineno_func + 4] "$script_name" 2>/dev/null | tail -n 8
}
construct_report_debug()
{
local call_level=${1:-5}
call_level=$[call_level-1]
# Generate calls stack trace.
for i in `seq $call_level ${#FUNCNAME[@]}`; do
[ "${FUNCNAME[$i]}" != "main" ] || break
local func_call="`sed -n -e "${BASH_LINENO[$i]}p" "${BASH_SOURCE[$[i+1]]}" 2>/dev/null |
sed -e 's/^[[:space:]]*//' -e 's/[[:space:]]*$//'`"
[ -n "$func_call" -a -z "${func_call##*${FUNCNAME[$i]}*}" ] || func_call="${FUNCNAME[$i]}"
echo "#$[i - $call_level] `readlink -m ${BASH_SOURCE[$[i+1]]}`(${BASH_LINENO[$i]}): $func_call"
done
}
construct_report_message()
{
product_and_problems_log_tail
echo ""
if [ -n "$report_context" ]; then
echo "Context: $report_context"
echo ""
fi
if [ -n "$RP_LOADED_PATCHES" ]; then
echo "Loaded runtime patches: $RP_LOADED_PATCHES"
echo ""
fi
}
# Construct report to send it to our errors tracker
construct_report()
{
local severity="${1:-error}"
local summary="$2"
[ -n "$summary" ] || int_err "Unable to send error report. Some parameters are not defined."
set_error_report_source
get_product_versions
construct_report_template "$severity" "$summary" \
| $PRODUCT_ROOT_D/admin/bin/send-error-report --version "$product_this_version" $report_source >/dev/null 2>&1
}
# Use this function to report failed actions.
# Typical report should contain
# - reason or problem description (example: file copying failed)
# - how to resolve or investigate problem (example: check file permissions, free disk space)
# - how to re-run action (example: perform specific command, restart bootstrapper script, run installation again)
report_problem()
{
local severity="${1:-error}"
# Get first string of error as a summary of report
shift
local summary="$1"
[ -n "$product_problems_log" ] || product_problems_log="/dev/stderr"
p_echo
if [ "0$problems_occured" -eq 0 ]; then
echo "***** $process problem report *****" >> "$product_problems_log" 2>&1
fi
for problem_message in "$@"; do
p_echo "$problem_message"
if [ "$product_log" != "$product_problems_log" ]; then
echo "$problem_message" >> "$product_problems_log" 2>&1
fi
done
p_echo
construct_report "$severity" "$summary"
[ -n "$PLESK_INSTALLER_DEBUG" -o -n "$PLESK_INSTALLER_VERBOSE" ] || \
product_log_tail
problems_occured=1
}
set_error_report_source()
{
[ -z "$1" ] || report_source="$1"
[ -n "$report_source" ] || {
if [ -n "$PACKAGE_ID" -o -n "$PACKAGE_ACTION" -o -n "$PACKAGE_NAME" -o -n "$PACKAGE_VERSION" ]; then
report_source="install"
else
report_source="backend"
fi
}
}
set_error_report_component()
{
local component="$1"
if [ "$report_source" = "install" ]; then
[ -n "$report_component" ] || report_component="$PACKAGE_ID"
return 0
fi
[ -z "$component" ] || report_component="$1"
[ -n "$report_component" ] || report_component="`basename $0`"
}
set_error_report_params()
{
if [ "$report_source" = "install" ]; then
[ -n "$report_params" ] || report_params="`echo "$PACKAGE_ACTION of $PACKAGE_NAME $PACKAGE_VERSION" | base64`"
return 0
fi
[ -z "$*" ] || report_params="`echo "$*" | base64`"
[ -n "$report_params" ] || report_params="`echo "$PLESK_SCRIPT_COMMAND_LINE" | base64`"
}
detect_virtualization()
{
detect_vz
detect_lxc
local is_docker="`[ -f "/.dockerenv" ] && echo yes || :`"
local systemd_detect_virt_ct="`/usr/bin/systemd-detect-virt -c 2>/dev/null | grep -v '^none$' || :`"
local systemd_detect_virt_vm="`/usr/bin/systemd-detect-virt -v 2>/dev/null | grep -v '^none$' || :`"
local virt_what="`/usr/sbin/virt-what 2>/dev/null | xargs || :`"
if [ -n "$is_docker" ]; then
echo "docker $virt_what"
elif [ "$PLESK_VZ" = "1" ]; then
echo "${PLESK_VZ_TYPE:-virtuozzo}"
elif [ "$PLESK_LXC" = "1" ]; then
echo "lxc $virt_what"
elif [ -n "$systemd_detect_virt_ct" ]; then
echo "$systemd_detect_virt_ct $systemd_detect_virt_vm"
elif [ -n "$virt_what" ]; then
echo "$virt_what"
elif [ -n "$systemd_detect_virt_vm" ]; then
echo "$systemd_detect_virt_vm"
fi
}
default_error_report_environment()
{
local virtualization="`detect_virtualization`"
if [ -n "$virtualization" ]; then
echo "virtualization: $virtualization"
fi
}
set_error_report_environment()
{
[ -z "$*" ] || report_environment="`echo "$*" | base64`"
[ -n "$report_environment" ] || report_environment="`default_error_report_environment | base64`"
}
get_update_ticket()
{
[ -r $PRODUCT_ROOT_D/var/update_ticket ] && cat $PRODUCT_ROOT_D/var/update_ticket | awk '{$1=$1};1'
}
### Copyright 1999-2025. WebPros International GmbH. All rights reserved.
#
# Support for runtime patching of shell scripts (including utilities and package scripts).
#
# --- Service functions ---
# Load and apply a patch in a relatively safe way
rp_safe_load_patch()
{
local patch_file="$1"
echo_try "load shell patch '$patch_file'"
/bin/sh -n "$RP_BASEDIR/$patch_file" &&
{
. "$RP_BASEDIR/$patch_file"
RP_LOADED_PATCHES="$RP_LOADED_PATCHES $patch_file"
} &&
suc
}
# Apply patches specific to the current context (e.g., depending on utility basename or package name)
# This is currently not implemented. This may be overriden by "spark".
rp_patch_runtime_context_specific()
{
:
}
# --- Main entry points ---
rp_patch_runtime()
{
# List of loaded patch files
RP_LOADED_PATCHES=
local RP_BASEDIR="$PRODUCT_BOOTSTRAPPER_DIR/rp"
[ -d "$RP_BASEDIR" ] || return 0
if [ -r "$RP_BASEDIR/spark" ]; then
rp_safe_load_patch "spark"
fi
call_optional_function rp_patch_runtime_context_specific "$@"
}
### Copyright 1999-2025. WebPros International GmbH. All rights reserved.
transaction_begin()
{
[ -n "$TRANSACTION_STARTED" ] && die "Another transaction in progress!"
TRANSACTION_STARTED="true"
TRANSACTION_ROLLBACK_FUNCS=
TRANSACTION_COMMIT_FUNCS=
local transaction_autocommit="$1"
if [ -n "$transaction_autocommit" ]; then
trap "transaction_commit_auto" EXIT
trap "transaction_rollback" HUP PIPE INT QUIT TERM
else
trap "transaction_rollback" HUP PIPE INT QUIT TERM EXIT
fi
}
transaction_rollback()
{
TRANSACTION_RETURN_CODE="${TRANSACTION_RETURN_CODE:-$?}"
[ -z "$TRANSACTION_STARTED" ] && die "Transaction is not started!"
# perform rollback actions
local f
for f in ${TRANSACTION_ROLLBACK_FUNCS}; do
"$f"
done
TRANSACTION_STARTED=
TRANSACTION_ROLLBACK_FUNCS=
TRANSACTION_COMMIT_FUNCS=
trap - HUP PIPE INT QUIT TERM EXIT
exit 1
}
transaction_commit()
{
TRANSACTION_RETURN_CODE="${TRANSACTION_RETURN_CODE:-$?}"
[ -z "$TRANSACTION_STARTED" ] && die "Transaction is not started!"
# perform commit actions
local f
for f in ${TRANSACTION_COMMIT_FUNCS}; do
"$f"
done
TRANSACTION_STARTED=
TRANSACTION_ROLLBACK_FUNCS=
TRANSACTION_COMMIT_FUNCS=
trap - HUP PIPE INT QUIT TERM EXIT
}
transaction_commit_auto()
{
TRANSACTION_RETURN_CODE="$?"
if [ "$TRANSACTION_RETURN_CODE" -eq 0 ]; then
transaction_commit "$@"
else
transaction_rollback "$@"
fi
}
transaction_add_rollback_action()
{
[ -z "$TRANSACTION_STARTED" ] && die "Transaction is not started!"
# LIFO rollback order
[ -z "$TRANSACTION_ROLLBACK_FUNCS" ] \
&& TRANSACTION_ROLLBACK_FUNCS="$1" \
|| TRANSACTION_ROLLBACK_FUNCS="$1 $TRANSACTION_ROLLBACK_FUNCS"
}
transaction_add_commit_action()
{
[ -z "$TRANSACTION_STARTED" ] && die "Transaction is not started!"
# FIFO commit order
[ -z "$TRANSACTION_COMMIT_FUNCS" ] \
&& TRANSACTION_COMMIT_FUNCS="$1" \
|| TRANSACTION_COMMIT_FUNCS="$TRANSACTION_COMMIT_FUNCS $1"
}
read_conf()
{
[ -n "$prod_conf_t" ] || prod_conf_t=/etc/psa/psa.conf
if [ -s $prod_conf_t ]; then
tmp_var=`perl -e 'undef $/; $_=<>; s/#.*$//gm;
s/^\s*(\S+)\s*/$1=/mg;
print' $prod_conf_t`
eval $tmp_var
else
if ! is_product_installation; then
p_echo "Unable to find product configuration file: $prod_conf_t. Default values will be used."
return 1
fi
fi
return 0
}
selinux_close()
{
if [ -z "$SELINUX_ENFORCE" -o "$SELINUX_ENFORCE" = "Disabled" ]; then
return
fi
setenforce "$SELINUX_ENFORCE"
}
### Copyright 1999-2025. WebPros International GmbH. All rights reserved.
# vim:ft=sh:
#set_params
set_common_params()
{
common_var=0
PATH=/sbin:/bin:/usr/sbin:/usr/bin:/usr/local/sbin:/usr/local/bin
LANG="`get_default_locale`"
export PATH LANG
unset GREP_OPTIONS
umask 022
ulimit -n 65535 2>/dev/null
get_product_versions
certificate_file="$PRODUCT_ETC_D/httpsd.pem"
services="/etc/services"
crontab="/usr/bin/crontab"
SYSTEM_RC_D="/etc/init.d"
PLESK_LIBEXEC_DIR="/usr/lib/plesk-9.0"
PLESK_DB_DIR="/var/lib/plesk"
PRODUCT_BOOTSTRAPPER_DIR="`printf "/opt/psa/bootstrapper/pp%s-bootstrapper" "$product_this_version"`"
AUTOGENERATED_CONFIGS="#ATTENTION!\n#\n#DO NOT MODIFY THIS FILE BECAUSE IT WAS GENERATED AUTOMATICALLY,\n#SO ALL YOUR CHANGES WILL BE LOST THE NEXT TIME THE FILE IS GENERATED.\n"
AUTOGENERATED_CONFIGS_UPGRADE="#ATTENTION!\n#\n#DO NOT MODIFY THIS FILE BECAUSE IT WAS GENERATED AUTOMATICALLY,\n#SO ALL YOUR CHANGES WILL BE LOST AFTER YOU UPGRADE PLESK.\n"
PRODUCT_LOGS_D="/var/log/plesk"
sendmail="/usr/sbin/sendmail"
ps="ps axw"
ifconfig="/sbin/ifconfig -a"
machine="linux"
if [ -f /etc/debian_version ]; then
linux_distr="debian"
else
linux_distr="redhat"
fi
dummy_home="/"
if [ -x /usr/sbin/nologin ]; then
dummy_shell="/usr/sbin/nologin"
else
dummy_shell="/bin/false"
fi
rp_patch_runtime
}
get_product_versions()
{
# Don't use global variables set elsewhere in this code. Use substitutions if needed.
local prod_root_d="/opt/psa"
product_name="psa"
if [ -z "$product_this_version" ]; then
# 1. Try to fetch version from file created by bootstrapper (should be 3-component).
product_this_version="`cat "/var/lock/plesk-target-version" 2>/dev/null`"
# 2. Fallback to $PRODUCT_ROOT_D/version (should be 3-component).
if [ -z "$product_this_version" -a -r "$prod_root_d/version" ]; then
product_this_version="`awk '{ print $1 }' "$prod_root_d/version"`"
fi
# 3. Fallback to hardcoded version (2-component). This may cause some other code to fail.
if [ -z "$product_this_version" ]; then
product_this_version="18.0"
echo "Unable to determine \$product_this_version, will use less precise value '$product_this_version'" >&2
fi
fi
product_version="$product_this_version"
if [ -z "$product_prev_version" ]; then
if [ -r "$prod_root_d/version.upg" ]; then
product_prev_version=`awk '{ print $1 }' "$prod_root_d/version.upg"`
elif [ -r "$prod_root_d/version" ]; then
product_prev_version=`awk '{ print $1 }' "$prod_root_d/version"`
else
product_prev_version="$product_this_version"
fi
fi
}
# Clean installation of the product is being performed
is_product_installation()
{
[ "X$do_upgrade" != "X1" -a ! -s "/opt/psa/version.upg" ]
}
### Copyright 1999-2025. WebPros International GmbH. All rights reserved.
# vim:syntax=sh
set_nginx_params()
{
nginx_service=nginx
nginx_rc_config="/etc/default/nginx"
nginx_user="nginx"
nginx_bin="/usr/sbin/nginx"
}
nginx_is_rc_enabled()
{
grep -q '^\s*NGINX_ENABLED=\s*"\?yes"\?\s*\(#.*\)\?$' "$nginx_rc_config" >/dev/null 2>&1
}
### Copyright 1999-2025. WebPros International GmbH. All rights reserved.
usage()
{
cat << EOT
Usage: httpd_modules_ctl [OPTIONS]...
Options:
-s, --status
-c, --check Check apache configuration for broken modules
-r, --repair Disable broken modules
-a, --all-modules Do not filter out required modules in --status command
-o, --modules Show status of specified modules only (with --status)
-e, --enable Turn on specified modules
-d, --disable Turn off specified modules
-M, --status-mpm List available/enabled mpm's
-m, --set-mpm Switch mpm
-R, --no-restart Do not restart apache
-h, --help Display this help and exit
EOT
return 1
}
short_module_name()
{
local fullname="$1"
local short_mod_name
short_mod_name=`expr match "$fullname" 'mod_\(.*\)$'`
if [ "$?" != "0" ] ; then
short_mod_name=`expr match "$fullname" 'lib\(.*\)$'`
[ "$?" = "0" ] || return 1
fi
echo $short_mod_name
}
is_module_enabled()
{
local short_mod_name="$1"
expr match "$short_mod_name" 'php7.*' 2>&1 > /dev/null
[ "$?" = "0" ] && short_mod_name="php7"
enabled_modules_list | grep -E "\<${short_mod_name}(_module|)\>" >/dev/null 2>&1
return $?
}
is_module_static()
{
local short_mod_name="$1"
static_modules_list | grep -E "\<(mod_|)${short_mod_name}\>" >/dev/null 2>&1
return $?
}
set_module_soname_and_config()
{
module_soname=""
module_config=""
if expr match "$module" 'php.*' 2>&1 > /dev/null; then
module_soname="lib$module.so"
module_config="$HTTPD_INCLUDE_D/php.conf"
fi
if [ "$module" = "pagespeed" ]; then
module_soname="mod_pagespeed_ap24.so"
fi
if [ "$module" = "dumpio" ]; then
module="dump_io"
fi
}
enable_mod()
{
local modules
local ret
local IFS
local module
local module_soname
local module_config
modules=$1
ret=0
IFS=,
for module in $modules ; do
if is_module_static "$module"; then
# Compiled in modules are always enabled
continue
fi
set_module_soname_and_config
if ! add_apache_module "$module" "$module_soname" "$module_config" ; then
ret=1
fi
done
return $ret
}
disable_mod()
{
local modules
local ret
local IFS
local module
local module_soname
local module_config
modules=$1
ret=0
IFS=,
for module in $modules ; do
if is_module_static "$module"; then
p_echo "ERROR: Module $module is compiled in (static) and cannot be disabled!"
ret=1
continue
fi
set_module_soname_and_config
if ! remove_apache_module "$module" "$module_soname" "$module_config" 2>> $product_log ; then
ret=1
fi
done
return $ret
}
status_mods()
{
local show_all_modules="$1"
# coma-separated list of modules (or empty):
local modules="${2:-}"
local all_mod_list
local ena_mod_list
local short_mod_name
local required_mods
local required_mods_re
local static_mod_list
if [ -n "$modules" ]; then
# a bit of hacking: prefix each module with 'mod_' to make short_module_name() happy
all_mod_list=`echo $modules | perl -nle 'print join(" ", map { "mod_".$_ } split(","))'`
else
all_mod_list=`all_modules_list`
required_mods=`required_modules_list`
fi
if [ "$show_all_modules" = "1" ]; then
static_mod_list=`static_modules_list`
all_mod_list="$all_mod_list $static_mod_list"
required_mods="$required_mods $static_mod_list"
fi
if [ -n "$required_mods" ] ; then
required_mods_re="`echo "$required_mods" | tr '\n' ' ' | sed -s 's/\s\+/\\\|/g'`\$"
fi
for mod in $all_mod_list; do
short_mod_name=`short_module_name $mod`
if [ "$?" != "0" ] ; then continue; fi
# use filter for required modules
if [ "$show_all_modules" = "1" -o -z "$required_mods_re" -o -n "$modules" ] || ! expr match "$short_mod_name" "$required_mods_re" 2>&1 > /dev/null ; then
if is_module_static "$short_mod_name"; then
echo "$short_mod_name static"
elif is_module_enabled "$short_mod_name"; then
echo "$short_mod_name on"
else
echo "$short_mod_name off"
fi
fi
done
return 0
}
status_mpm()
{
local output
local ret
output=`status_mods 1`
ret="$?"
[ "$ret" = "0" ] || return "$ret"
echo "$output" | grep '^mpm_'
}
switch_mpm()
{
local to="$1"
local mpms IFS
mpms="`status_mpm`"
IFS="
"
for ms in $mpms; do
local mod=`echo $ms | cut -d' ' -f 1`
if [ "$mod" != "$to" ]; then
disable_mod "$mod"
fi
done
enable_mod "$to"
if [ "$to" = "mpm_event" ]; then
# assume no more than one mod_php version is installed
local short_php_mod_name="`short_module_name $(all_modules_list | grep 'php[57]')`"
if [ -n "$short_php_mod_name" ]; then
disable_mod "$short_php_mod_name"
fi
fi
}
static_modules_list()
{
if [ -z "$VAR_STATIC_MODULES_LIST_EVALUATED" ]; then
local static_mod_list
static_mod_list="`$HTTPD_CTL_MODULES -l | awk '$1 ~ /\.c$/ {print $1}' | cut -d. -f1 2>> "$product_log"`"
VAR_STATIC_MODULES_LIST="`echo "$static_mod_list" | grep -E -v '^(core|http_core|prefork)$'`"
VAR_STATIC_MODULES_LIST_EVALUATED=1
fi
echo "$VAR_STATIC_MODULES_LIST"
}
required_modules_list()
{
echo "env authn_file authz_host authz_user actions alias proxy.plesk proxy_fcgi.plesk mime ssl"
set_nginx_params
nginx_is_rc_enabled && echo "remoteip aclr"
# mod_security and unique_id
local mod_security_version=`$PRODUCT_ROOT_D/admin/sbin/packagemng --list | awk -F: '$1 ~ /^modsecurity$/ {print $2}'`
if [ -n "$mod_security_version" ]; then
echo "security2"
if is_module_enabled "security2"; then
echo "unique_id"
fi
fi
}
all_modules_list()
{
ls "$apache_modules_d" -I "mod_pagespeed*" -I "mod_cgi*" -I "mod_case_filter*" | grep '\.so$' | sed 's/\.so//'
if [ -f "$apache_modules_d/mod_pagespeed_ap24.so" ]; then
echo "mod_pagespeed"
fi
if [ -f "$apache_modules_d/mod_cgid.so" ]; then
echo "mod_cgid"
fi
if [ -f "$apache_modules_d/mod_cgi.so" ]; then
echo "mod_cgi"
fi
}
enabled_modules_list_aux()
{
local ena_mod_list
ena_mod_list=`$HTTPD_CTL_MODULES -M 2>&1`
if [ "$?" = "0" ] ; then
echo "$ena_mod_list" | awk '$1 ~ /module/ {print $1}'
return 0
fi
case "$linux_distr" in
debian)
ena_mod_list=`ls /etc/apache2/mods-enabled/*.load | xargs -n 1 basename | sed 's/\.load//' 2>> $product_log`
ena_mod_list_ret=$?
if [ "$ena_mod_list_ret" != "0" ] ; then
echo "$ena_mod_list_ret" >> $product_log
return 1
fi
echo $ena_mod_list
return 0
;;
redhat*)
find /etc/httpd/conf/ /etc/httpd/conf.d/ -maxdepth 1 -type f -exec grep -h LoadModule {} \; | \
perl -nale 'unless(m/^\s*#/) { print substr($F[1], 0, -7) }'
return $?
;;
esac
return 1
}
enabled_modules_list()
{
if [ -z "$VAR_ENABLED_MODULES_LIST_EVALUATED" ]; then
VAR_ENABLED_MODULES_LIST=`enabled_modules_list_aux`
VAR_ENABLED_MODULES_LIST_EVALUATED=1
fi
echo "$VAR_ENABLED_MODULES_LIST"
}
get_broken_modules()
{
local apachectl_out
local apachectl_ret
apachectl_out=`LANG=C LC_ALL=C /usr/sbin/apache2ctl configtest 2>&1 >/dev/null`
apachectl_ret=$?
if [ $apachectl_ret -eq 0 ]; then
return
fi
local broken_list=$(echo "$apachectl_out" | perl -nale 'print "$1\n" if /Cannot load (.*?).so into server/')
for m in $broken_list; do
m=`basename $m`
short_module_name $m
done
}
check_broken_modules()
{
for m in `get_broken_modules`; do
echo "Apache module $m cannot be loaded"
done
}
repair_broken_modules()
{
local broken_modules=`get_broken_modules`
[ -n "$broken_modules" ] || return
for m in $broken_modules; do
disable_mod $m
done
}
## begin script
reexec_with_clean_env "$@"
if [ $# -eq 0 ] ; then
usage
exit 1
fi
log_transaction_start "httpd_modules_ctl${*:+ $*}" "" "httpd_modules_ctl.XXXXXX"
read_conf
set_common_params
set_apache_params
# Starting from the RedHat 9, apachectl doesn't pass arbitrary option to httpd,
# so, for detecting modules we cannot use it. But, on Debian and Ubuntu HTTPD_BIN
# fails because of missing environment variables, so we should use HTTPD_CTL there.
HTTPD_CTL_MODULES="/usr/sbin/apache2ctl"
# Initialize modules lists (in the outer shell)
enabled_modules_list >/dev/null
static_modules_list >/dev/null
TEMP=`getopt -o e:d:so:aMm:Rcrh \
--long enable:,disable:,status,modules:,all-modules,status-mpm,set-mpm:,no-restart,check,repair,help -n "$0" -- "$@"`
if [ $? != 0 ] ; then
echo "Terminating..." >&2
rm -f $product_log
exit 1
fi
eval set -- "$TEMP"
ret=0
to_restart=0
opt_status=0
opt_status_mpm=0
opt_all_modules=0
opt_modules=
opt_no_restart=0
while true ; do
case "$1" in
-e|--enable)
enable_mod $2
ret=`expr $ret \| $?`
to_restart=1
shift 2
;;
-d|--disable)
disable_mod $2
ret=`expr $ret \| $?`
to_restart=1
shift 2
;;
-m|--set-mpm)
switch_mpm "$2"
ret=`expr $ret \| $?`
to_restart=1
shift 2
;;
-s|--status)
opt_status=1
shift
;;
-o|--modules)
opt_modules="$2"
shift 2
;;
-M|--status-mpm)
opt_status_mpm=1
shift
;;
-a|--all-modules)
opt_all_modules=1
shift
;;
-R|--no-restart)
opt_no_restart=1
shift
;;
-c|--check)
check_broken_modules
exit $?
shift
;;
-r|--repair)
repair_broken_modules
exit $?
shift
;;
-h|--help)
usage
rm -f $product_log
exit $?
;;
--) shift ; break ;;
*) p_echo "Internal error: unhandled option $1" ;
rm -f "$product_log"
exit 1
;;
esac
done
if [ "$opt_status" = "1" ]; then
if [ "$opt_all_modules" = '1' -a -n "$opt_modules" ]; then
echo "Error: options --all-modules and --modules should not be specified together" >&2
exit 1
fi
status_mods_output=`status_mods $opt_all_modules $opt_modules`
ret=$?
if [ "$ret" = "0" ]; then
if [ -n "$opt_modules" ]; then
# do not sort explicitly specified modules
echo "$status_mods_output"
else
echo "$status_mods_output" | sort
fi
fi
elif [ "$opt_status_mpm" = "1" ]; then
status_mpm_output=`status_mpm`
ret=$?
[ "$ret" != "0" ] || echo "$status_mpm_output" | sort
fi
if [ "$to_restart" != "0" -a "$opt_no_restart" = "0" ] ; then
# Restart web server
if ! "$PRODUCT_ROOT_D/admin/sbin/apache_control_adapter" --restart >> "$product_log" 2>&1 ; then
ret=1
fi
fi
if [ "$ret" != "0" ]; then
# Operation completed with errors. Cat $product_log on stderr
cat $product_log >&2
fi
rm -f "$product_log"
exit $ret
# vim:ft=sh